/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package fjsproyect;

import java.util.HashMap;
import java.util.LinkedList;

/**
 *
 * @author Andres_Garcia
 */
public class Operation {
    private String id;
    private int job;
    private int machineAssigned;
    private int timeMachine;
    private int startTime;
    private int completionTime;
    private int tailMax; //Cola más larga
    private int numberOfArcs;
    private HashMap<Integer, Integer> timesInMachine; //Contenedor de referencias para los tiempos en máquina
    private HashMap<Integer, Integer> jobsTails;
    private HashMap<Integer, Boolean> criticalToJob;
    private String nextOperationByJob;
    private String nextOperationByMachine;
    private String previewOperationByJob;
    private String previewOperationByMachine;
    private int status; //If the operation was assigned (1) to any machine otherwise 0
    private int orderinMachine; // En qué orden la operación fue hecha dentro de la máquina
    private LinkedList<String> succesors;
    
   public final static int MINIMUN_TAIL = -1000000000; //This is minus infinity

    public Operation() {
        this.id = "";
        this.job = 0;
        this.machineAssigned = 0;
        this.timeMachine = 0;
        this.startTime = 0;
        this.completionTime = 0;
        this.tailMax = 0;
        this.numberOfArcs = 0;
        this.timesInMachine = new HashMap<Integer, Integer>();
        this.jobsTails = new HashMap<Integer, Integer>();
        this.criticalToJob = new HashMap<Integer, Boolean>();
        this.nextOperationByJob = "";
        this.nextOperationByMachine = "endMachine";
        this.previewOperationByJob = "";
        this.previewOperationByMachine = "start";
        //this.status=0;
        this.succesors=new LinkedList<String>();
    }
    
   public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public int getJob() {
        return job;
    }

    public void setJob(int job) {
        this.job = job;
    }

    public int getMachineAssigned() {
        return machineAssigned;
    }

    public void setMachineAssigned(int machineAssigned) {
        this.machineAssigned = machineAssigned;
    }

    public int getTimeMachine() {
        return timeMachine;
    }

    public void setTimeMachine(int timeMachine) {
        this.timeMachine = timeMachine;
    }

    public int getStartTime() {
        return startTime;
    }

    public void setStartTime(int startTime) {
        this.startTime = startTime;
    }

    public int getCompletionTime() {
        return completionTime;
    }

    public void setCompletionTime(int completionTime) {
        this.completionTime = completionTime;
    }

    public int getTailMax() {
        return tailMax;
    }

    public void setTailMax(int tailMax) {
        this.tailMax = tailMax;
    }

    public int getNumberOfArcs() {
        return numberOfArcs;
    }

    public void setNumberOfArcs(int numberOfArcs) {
        this.numberOfArcs = numberOfArcs;
    }

    public HashMap<Integer, Integer> getTimesInMachine() {
        return timesInMachine;
    }

    public void setTimesInMachine(HashMap<Integer, Integer> timesInMachine) {
        this.timesInMachine = timesInMachine;
    }

    public HashMap<Integer, Integer> getJobsTails() {
        return jobsTails;
    }

    public void setJobsTails(HashMap<Integer, Integer> jobsTails) {
        this.jobsTails = jobsTails;
    }

    public HashMap<Integer, Boolean> getCriticalToJob() {
        return criticalToJob;
    }

    public void setCriticalToJob(HashMap<Integer, Boolean> criticalToJob) {
        this.criticalToJob = criticalToJob;
    }

    

    public String getNextOperationByJob() {
        return nextOperationByJob;
    }

    public void setNextOperationByJob(String nextOperationByJob) {
        this.nextOperationByJob = nextOperationByJob;
    }

    public String getNextOperationByMachine() {
        return nextOperationByMachine;
    }

    public void setNextOperationByMachine(String nextOperationByMachine) {
        this.nextOperationByMachine = nextOperationByMachine;
    }

    public String getPreviewOperationByJob() {
        return previewOperationByJob;
    }

    public void setPreviewOperationByJob(String previewOperationByJob) {
        this.previewOperationByJob = previewOperationByJob;
    }

    public String getPreviewOperationByMachine() {
        return previewOperationByMachine;
    }

    public void setPreviewOperationByMachine(String previewOperationByMachine) {
        this.previewOperationByMachine = previewOperationByMachine;
    }
   
    public void addOptionMachine(int idMachine, int timeMach) {
        timesInMachine.put(idMachine, timeMach);
    }

    public int findTimeInMachine(int machine) {
        int time = 0;
        if (timesInMachine.containsKey(machine)) {
            time = (int) timesInMachine.get(machine);
        }
        return time;

    }
    
    public void addTail(int job, int time) {
        jobsTails.put(job, time);    
    }

    public int getStatus() {
        return status;
    }

    public void setStatus(int status) {
         this.status = status;
    }
   
    public int findJobsTail(int job) {
        int time = MINIMUN_TAIL;
        if (jobsTails.containsKey(job)) {
            time = jobsTails.get(job);
        }
        return time;
    }

    public int getOrderinMachine() {
        return orderinMachine;
    }

    public void setOrderinMachine(int orderinMachine) {
        this.orderinMachine = orderinMachine;
    }
    
    public int timeInMachine(int machine){
        return timesInMachine.get(machine);
    }
    
    public void criticalToJob(int job) {

        if (job != 0) {
            criticalToJob.put(job, Boolean.TRUE);
        }
    }

    public LinkedList<String> getSuccesors() {
        return succesors;
    }

    public void setSuccesors(LinkedList<String> succesors) {
        this.succesors = succesors;
    }
    
    
    //Add a single operation as a succesor i.e next by machine or next by job
    public void addsuccesor(String operation) {
        succesors.add(operation);
    }
    
    //Add all succesor of an operation if 
    public void addsuccesors(LinkedList<String> operations) {
        succesors.addAll(operations);
    }
    //Repeated succesors by machine are listed to remove the repeated operations
    public void addsuccesorsTotal() {
        for (int i = 0; i < succesors.size(); i++) {
            for (int j = i + 1; j < succesors.size(); j++) {
                if (succesors.get(i).contentEquals(succesors.get(j))) {
                    succesors.remove(j);
                    break;
                }
            }
        }
    }
    
    //Clear the succesor set
    public void clearSuccesors() {
        this.succesors.clear();
        
    }
   
    public void notCriticalToJob(int job) {

        if (job != 0) {
            criticalToJob.put(job, Boolean.FALSE);
        }
    }
    
    public void clearData() {
        this.criticalToJob.clear();
        this.jobsTails.clear();
        
    }
    
    
    
    
    
    
    
    
}
